<?php
/**
 * @version    $Id$
 * @package    SUN Framework
 * @author     JoomlaShine Team <support@joomlashine.com>
 * @copyright  Copyright (C) 2012 JoomlaShine.com. All Rights Reserved.
 * @license    GNU/GPL v2 or later http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Websites: http://www.joomlashine.com
 * Technical Support:  Feedback - http://www.joomlashine.com/contact-us/get-support.html
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * Menu item selector widget.
 *
 * @package  SUN Framework
 * @since    1.0.0
 */
class SunFwAjaxSelector extends SunFwAjax
{
	/**
	 * Render a list of filter options for the state of an item.
	 *
	 * @param   string  $selected    Currently selected option.
	 * @param   string  $name        Name of input field.
	 * @param   string  $parameters  Additional attributes of input field.
	 *
	 * @return  void
	 */
	public function renderStateOptions($selected, $name, $parameters = '')
	{
		$options = array(
			JHtml::_( 'select.option', '*', JText::_('SUNFW_ANY_STATUS') ),
			JHtml::_( 'select.option', '1', JText::_('JPUBLISHED') ),
			JHtml::_( 'select.option', '0', JText::_('JUNPUBLISHED') ),
			JHtml::_( 'select.option', '-2', JText::_('JTRASHED') ),
		);

		echo JHTML::_('select.genericlist', $options, $name, $parameters, 'value', 'text', $selected);
	}

	/**
	 * Render a list of access options.
	 *
	 * @param   string  $selected    Currently selected option.
	 * @param   string  $name        Name of input field.
	 * @param   string  $parameters  Additional attributes of input field.
	 *
	 * @return  void
	 */
	public function renderAccessOptions($selected, $name, $parameters = '')
	{
		$options = array( (object) array('text' => JText::_('SUNFW_ANY_ACCESS'), 'value' => '') );

		echo JHtml::_('access.level', $name, $selected, $parameters, $options);
	}

	/**
	 * Render a list of language options.
	 *
	 * @param   string  $selected    Currently selected option.
	 * @param   string  $name        Name of input field.
	 * @param   string  $parameters  Additional attributes of input field.
	 *
	 * @return  void
	 */
	public function renderLanguageOptions($selected, $name, $parameters = '')
	{
		if ( $options = JHtml::_('contentlanguage.existing') )
		{
			array_unshift( $options, (object) array('text' => JText::_('SUNFW_ANY_LANGUAGE'), 'value' => '') );
		}
		else
		{
			$options = array( (object) array('text' => JText::_('SUNFW_ANY_LANGUAGE'), 'value' => '') );
		}

		echo JHTML::_('select.genericlist', $options, $name, $parameters, 'value', 'text', $selected);
	}

	/**
	 * Get items.
	 *
	 * @return  array
	 */
	public function getItems()
	{
		return $this->dbo->setQuery( $this->getListQuery() )->loadObjectList();
	}
}
