<?php
use Joomla\Session\Storage\Database;

/**
 * @version    $Id$
 * @package    SUN Framework
 * @author     JoomlaShine Team <support@joomlashine.com>
 * @copyright  Copyright (C) 2012 JoomlaShine.com. All Rights Reserved.
 * @license    GNU/GPL v2 or later http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Websites: http://www.joomlashine.com
 * Technical Support:  Feedback - http://www.joomlashine.com/contact-us/get-support.html
 */

// No direct access to this file.
defined('_JEXEC') or die('Restricted access');

// Import necessary libraries.
jimport('joomla.filesystem.file');

/**
 * Installer class.
 *
 * @package  SUN Framework
 * @since    1.0.0
 */
class PlgSystemSunFwInstallerScript
{
	/**
	 * Implement preflight hook.
	 *
	 * This step will be verify permission for install/update process.
	 *
	 * @param   string  $route  Route type: install, update or uninstall.
	 * @param   object  $_this  The installer object.
	 *
	 * @return  boolean
	 */
	public function preflight ($route, $_this)
	{
		// Remove obsolete file in target directory if exists.
		if ( JFile::exists(JPATH_ROOT . '/plugins/system/sunfw/database/mysql/updates/1.3.1.sql') )
		{
			JFile::delete(JPATH_ROOT . '/plugins/system/sunfw/database/mysql/updates/1.3.1.sql');

			// Check if the column 'social_share_data' exists in the '#__sunfw_styles' table?
			$dbo = JFactory::getDbo();

			if ( $columns = $dbo->setQuery('SHOW COLUMNS FROM #__sunfw_styles')->loadColumn() )
			{
				if ( in_array('social_share_data', $columns) )
				{
					// Rename SQL update file of v2.0.0
					$source = $_this->getParent()->getPath('source');

					if ( JFile::exists("{$source}/database/mysql/updates/2.0.0.sql") )
					{
						JFile::move("{$source}/database/mysql/updates/2.0.0.sql", "{$source}/database/mysql/updates/2.0.0.bak");
					}
				}
			}
		}
	}

	/**
	 * Implement postflight hook.
	 *
	 * @param   string  $route  Route type: install, update or uninstall.
	 * @param   object  $_this  The installer object.
	 *
	 * @return  boolean
	 */
	public function postflight($route, $_this)
	{
		// Get a database connector object.
		$db = JFactory::getDbo();

		try
		{
			// Enable plugin by default.
			$sql = $db->getQuery(true);

			$sql->update('#__extensions')
				->set(array('enabled = 1', 'protected = 1', 'ordering = 0'))
				->where("element = 'sunfw'")
				->where("type = 'plugin'")
				->where("folder = 'system'");

			$db->setQuery($sql)->execute();
		}
		catch (Exception $e)
		{
			throw $e;
		}
	}
}
